#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << x << endl
#else
#   define DEBUG(x)
#endif

struct pair_hasher {
    size_t operator()(const pair<int, int>& x) const {
        return x.first * 119 + x.second;
    }
};

int main() {
    const int n = 5;
    int grid[][n] = {
        {3, 7, 9, 2, 7},
        {9, 8, 3, 5, 5},
        {1, 7, 9, 8, 5},
        {3, 8, 6, 4, 10},
        {6, 3, 9, 7, 8}
    };
    
    {
        // store results in
        //      int => (int => int)
        unordered_map<int, unordered_map<int, int>> res;
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                res[i][j] = grid[i][j] + max(res[i-1][j], res[i][j-1]);
            }
        }
        cout << res[n-1][n-1] << endl;
    }
    
    {
        // store results in
        //      (int,int) => int
        unordered_map<pair<int, int>, int, pair_hasher> res;
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                res[{i,j}] = grid[i][j] + max(res[{i-1,j}], res[{i,j-1}]);
            }
        }
        cout << res[{n-1,n-1}] << endl;
    }
    
    
    return 0;
}
